@echo off
::
:: Lines beginning with "::" are inactive.
::
::-@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@-<
::
:: Purpose:
:: ~~~~~~~~
:: This batch code can:  (1) clear the console screen, (2) change the
:: console screen mode (number of columns and lines), and (3) change the
:: background and foreground (text) display colors.
::
::-------------------------------------------------------------------------<
::
:: Requirements:
:: ~~~~~~~~~~~~~
:: * MS-DOS [*] Protected-mode ... (with Win9x ... running)
::          [*] Real-mode ........ (with Win9x NOT running)
:: * MS-DOS External Command Program(s):
::   -     FIND.EXE
::   -     MODE.COM
::   - BATCHMAN.COM (v1.1) (by Michael J Mefford)
::                  (MD5:  753c4c21960b59f5f59ad7e147ff081d  BATCHMAN.COM)
::                  ftp://ftp.elf.stuba.sk/pub/pc/utiltask/batchman.zip
::
::-------------------------------------------------------------------------<
::
:: Notes:
:: ~~~~~~
:: * For usage, type "CLR /?".
::
::- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -<
::
::                                       /
:: Usage: CLR [CL] [[@]#]                | Examples: CLR 9C 8050  /  CLR E
::                                       |           CLR 4043    /   CLR
::    C - Number of Columns [80/40]      \---------------------------------/
::    L - Number of Lines   [50/43/25]
::    @ - Background Color  [0/1/2/3/4/5/6/7/8/9/A/B/C/D/E/F] (cannot = [#])
::    # - Foreground Color  [0/1/2/3/4/5/6/7/8/9/A/B/C/D/E/F] (cannot = [@])
::              /---------------------------------------------------------\
:: Color Chart: | Dark Colors | Light Colors | Dark Colors | Light Colors |
::              | ----------- | ------------ | ----------- | ------------ |
::              |   Black - 0 | 8 - Gray     |  Maroon - 4 | C - Red      |
::              |    Navy - 1 | 9 - Blue     |  Purple - 5 | D - Fuchsia  |
::              |   Green - 2 | A - Lime     |   Olive - 6 | E - Yellow   |
::              |    Teal - 3 | B - Aqua     |  Silver - 7 | F - White    |
::              \---------------------------------------------------------/
:: Requirements: BATCHMAN.COM (v1.1)
::
::- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -<
::
:: * The parameters "CL" and "@#" can be given in any order.
::
:: * Both "C" and "L" must be supplied, if either (and in that order...CL).
::
:: * If "@" is not supplied (while "#" is), the background color defaults to
::   0 (black).
::
:: * "@" and "#" must be different so as to avoid the unreadable situation
::   where the text color is the same as the background color.            ;)
::
:: * Under real-mode DOS (with Windows NOT running), any color combinations
::   where the background color is one of these (@: 8 9 A B C D E F) colors
::   will produce a blinking text effect.
::
:: * Ironically, in real-mode DOS the color pairs
::   (@#: 88 99 AA BB CC DD EE FF) actually produce readable text on screen
::   (though blinking).  This program does not allow these color combos,
::   however, since it does know whether it is being run under a real-mode
::   DOS environment or a protected-mode (with Windows running) DOS
::   environment.
::
:: * Under real-mode DOS any of these color combinations
::   (@#: 80 91 A2 B3 C4 D5 E6 F7) will cause an effect where nothing
::   appears on screen (there's actually blinking text that is the same
::   color as the background).
::
::-------------------------------------------------------------------------<
::
:: About:                                               (06-06-2009)
:: ~~~~~~
:: CLR.BAT (v1.3)
::
::      Bla
::      P.O. Box NUL
::      Valley View, Ohio 44125 USA
::
::      E-Mail:   Blaware@FastMail.fm
::      Webpage:  http://www.NUL.nul/index.html
::
:: Feed the birds.  (Why?)  Well, they haven't pecked your eyes out!
::
::-#######################################################################-<
::
echo z | find "z" > NUL
batchman month
if not errorlevel 1 goto MESSAGE
if .%1.==.. goto 0L
if not .%3.==.. goto HELP
echo -h/H?-?/?--HELP | find /i "%1" > NUL
if not errorlevel 1 goto HELP
for %%A in (CZ8 CZ5) do set %%A=
set CZ9=%1
if not .%2.==.. set CZ8=%2
if not .%CZ8%.==.. if .%1.==.%2. goto HELP
set CZ7=%CZ9%
goto 0H
:0G
set CZ7=%CZ8%
:0H
set CZ6=0
echo 123456789ABCDEF | find /i "%CZ7%" > NUL
if not errorlevel 1 goto 0I
set CZ6=
echo 0102030405060708090A0B0C0D0E0F1012131415161718191A1B1C1D1E1F | find /i "%CZ7%" > NUL
if not errorlevel 1 goto 0I
echo 2021232425262728292A2B2C2D2E2F3031323435363738393A3B3C3D3E3F | find /i "%CZ7%" > NUL
if not errorlevel 1 goto 0I
echo 4041424345464748494A4B4C4D4E4F5051525354565758595A5B5C5D5E5F | find /i "%CZ7%" > NUL
if not errorlevel 1 goto 0I
echo 6061626364656768696A6B6C6D6E6F7071727374757678797A7B7C7D7E7F | find /i "%CZ7%" > NUL
if not errorlevel 1 goto 0I
echo 8081828384858687898A8B8C8D8E8F9091929394959697989A9B9C9D9E9F | find /i "%CZ7%" > NUL
if not errorlevel 1 goto 0I
echo A0A1A2A3A4A5A6A7A8A9ABACADAEAFB0B1B2B3B4B5B6B7B8B9BABCBDBEBF | find /i "%CZ7%" > NUL
if not errorlevel 1 goto 0I
echo C0C1C2C3C4C5C6C7C8C9CACBCDCECFD0D1D2D3D4D5D6D7D8D9DADBDCDEDF | find /i "%CZ7%" > NUL
if not errorlevel 1 goto 0I
echo E0E1E2E3E4E5E6E7E8E9EAEBECEDEFF0F1F2F3F4F5F6F7F8F9FAFBFCFDFE | find /i "%CZ7%" > NUL
if not errorlevel 1 goto 0I
goto 0J
:0I
if .%CZ7%.==.%CZ8%. goto %CZ5%
if .%CZ8%.==.. goto 0L
for %%B in (8050 8025 8043 4050 4025 4043) do if .%CZ8%.==.%%B. goto %%B
goto HELP
:0J
if .%CZ7%.==.%CZ8%. goto HELP
for %%C in (8050 8025 8043 4050 4025 4043) do if .%CZ9%.==.%%C. set CZ5=%%C
if not .%CZ5%.==.. if not .%CZ8%.==.. goto 0G
if not .%CZ5%.==.. goto %CZ5%
goto HELP
::
:MESSAGE
echo.
echo  CLR.BAT -- Clears console screen; Changes console screen mode (number of
echo  *******    columns and lines); Changes background/foreground display colors.
echo             Type "CLR /?" for usage.
echo.
goto 0M
::
:HELP
echo.
echo  CLR.BAT -- Clears console screen; Changes console screen mode (number of
echo  *******    columns and lines); Changes background/foreground display colors.
echo                                        
echo  Usage: CLR [CL] [[@]#]                 Examples: CLR 9C 8050  /  CLR E
echo                                                   CLR 4043    /   CLR
echo     C - Number of Columns [80/40]      
echo     L - Number of Lines   [50/43/25]
echo     @ - Background Color  [0/1/2/3/4/5/6/7/8/9/A/B/C/D/E/F] (cannot = [#])
echo     # - Foreground Color  [0/1/2/3/4/5/6/7/8/9/A/B/C/D/E/F] (cannot = [@])
echo               Ŀ
echo  Color Chart:  Dark Colors  Light Colors  Dark Colors  Light Colors 
echo                -----------  ------------  -----------  ------------ 
echo                  Black - 0  8 - Gray       Maroon - 4  C - Red      
echo                   Navy - 1  9 - Blue       Purple - 5  D - Fuchsia  
echo                  Green - 2  A - Lime        Olive - 6  E - Yellow   
echo                   Teal - 3  B - Aqua       Silver - 7  F - White    
echo               
echo  Requirements: BATCHMAN.COM (v1.1)
echo.
goto 0M
::
:8050
mode con: cols=80 lines=50
goto 0K
:8025
mode con: cols=80 lines=25
goto 0K
:8043
mode con: cols=80 lines=43
goto 0K
:4050
mode con: cols=40 lines=50
goto 0K
:4025
mode con: cols=40 lines=25
goto 0K
:4043
mode con: cols=40 lines=43
:0K
if .%2.==.. goto 0M
for %%D in (8050 8025 8043 4050 4025 4043) do if .%CZ9%.==.%%D. set CZ9=
for %%E in (8050 8025 8043 4050 4025 4043) do if .%CZ8%.==.%%E. set CZ8=
:0L
if .%1.==.. batchman cls
if not .%1.==.. batchman cls %CZ6%%CZ9%%CZ8%h
:0M
for %%F in (CZ9 CZ8 CZ7 CZ6 CZ5) do set %%F=
:END