@echo off
::
:: Lines beginning with "::" are inactive.
::
::-@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@-<
::
:: Purpose:
:: ~~~~~~~~
:: This batch code creates an 8.3(max)-character random filename (such as
:: "#" or "Z3^AHJO!.X)B" and SETs it to the environment variable:  %RFN%.
::
::-------------------------------------------------------------------------<
::
:: Requirements:
:: ~~~~~~~~~~~~~
:: * MS-DOS [*] Protected-mode ... (with Win9x ... running)
::          [*] Real-mode ........ (with Win9x NOT running)
:: * MS-DOS External Command Program(s):
::   -     FIND.EXE
::   -   MD5SUM.EXE (Branko Lankester, Colin Plumb, & Michael Paul Johnson)
::                  (MD5:  ffbfbcc238f518b079dc8e00452c0ce1  MD5SUM.EXE)
::                  ftp://ftp.elf.stuba.sk/pub/pc/security/md5sum.zip
::                  http://ebible.org/mpj/software.htm
::   -     NSET.COM (v2.1) (by Horst Schaeffer)
::                  (MD5:  2d09602c021592df1659c78b3df8ec6c  NSET.COM)
::                  ftp://ftp.elf.stuba.sk/pub/pc/utiltask/horst31.zip
:: * Microsoft Windows 9x temporary directory:  (C:\Path\To\Temp\)
::
::-------------------------------------------------------------------------<
::
:: Notes:
:: ~~~~~~
:: * For usage, type "RFN /?".
::
::- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -<
::
::                                                 /
::                                                 | Examples: RFN 8.2 d
:: Usage: RFN [n[.x]] [[d]/[f/i]] [t/w] [e]        |           RFN 2 i T E
::            ---1--- -----2----- --3-- -4-        \-----------------------/
::
::   n - Number of characters in RFN (root); must be (1-8) ...... (required)
::  .x - (1-3) character eXtension; may be trimmed if [i] is used (optional)
::   d - Demo: Just ECHO the RFN to screen (don't SET "RFN" EV) . (optional)
::   f - Full: Always generates [n[.x]] characters .............. (optional)
::   i - Incremental: Generates [n[.x]] chars (if necessary) .... (optional)
::   t - Temp: RFN can exist in TEMP directory (requires [f/i]) . (optional)
::   w - Work: RFN can exist in WORK directory (requires [f/i]) . (optional)
::   e - Echo: Just ECHO the RFN to screen (don't SET "RFN" EV) . (optional)
::   / - Choose one or the other, not both
::
::   Note: Parameter 4 requires a Parameter 3, Param3 requires a Param2,...
::
:: Requirements: MD5SUM.EXE / NSET.COM (v2.1)
::
::- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -<
::
:: * This batch code does not create any intermediate files or folders
::   during it's operation.
::
:: * If no 2nd parameter is given, the "RFN" environment variable is SET.
::
:: * If the 3rd parameter is rogue (not [t/w]), then [e] would be ignored.
::
:: * If [i] is used with a rogue 3rd parameter (not [t/w]), then [f] is
::   assumed instead of [i].
::
:: * The program does not test to see if a %TEMP% directory is writable or
::   even exists (of course it should exist and be writable).
::
:: * If the [t] option is used and the %TEMP% value has an embedded [Space]
::   in it, the program will fail.  Of course, this should never be the
::   case.
::
:: * The program could conceivably run indefinitely if [t/w] is used and it
::   cannot find a filename that can exist in that directory.  It's hard to
::   imagine that this could ever be the case, however.  Most likely "n"
::   would have to be "1" and all 50 possible characters would have to
::   pre-exist in the directory as either a filename or foldername.
::
::-------------------------------------------------------------------------<
::
:: About:                                               (06-06-2009)
:: ~~~~~~
:: RFN.BAT (v1.3)
::
::      Bla
::      P.O. Box NUL
::      Valley View, Ohio 44125 USA
::
::      E-Mail:   Blaware@FastMail.fm
::      Webpage:  http://www.NUL.nul/index.html
::
:: Feed the birds.  (Why?)  Well, they haven't pecked your eyes out!
::
::-#######################################################################-<
::
ctty nul
if .%1.==.. goto MESSAGE
if not .%5.==.. goto HELP
echo -h/H?-?/?--HELP | find /i "%1" > NUL
if not errorlevel 1 goto HELP
for %%A in (RZ9 RZ8 RZ7 RZ2) do set %%A=
for %%B in (8 7 6 5 4 3 2 1 8.3 7.3 6.3 5.3 4.3 3.3 2.3 1.3) do if .%1.==.%%B. goto 0G
for %%C in (8.2 7.2 6.2 5.2 4.2 3.2 2.2 1.2 8.1 7.1 6.1 5.1 4.1 3.1 2.1 1.1) do if .%1.==.%%C. goto 0G
goto HELP
:0G
for %%D in (D d) do if .%2.==.%%D. if not .%3.==.. goto HELP
for %%E in (D d) do if .%2.==.%%E. set RZ9=#
if .%RZ9%.==.#. goto 0J
for %%F in (F f I i) do if .%2.==.%%F. goto 0H
if not .%2.==.. goto HELP
:0H
for %%G in (I i) do if .%2.==.%%G. set RZ8=i
for %%H in (W w T t) do if .%3.==.%%H. goto 0I
if not .%3.==.. set RZ8=
goto 0J
:0I
for %%I in (W w) do if .%3.==.%%I. set RZ7=.
for %%J in (T t) do if .%3.==.%%J. set RZ7=%TEMP%
if .%4.==.. goto 0J
for %%K in (E e) do if .%4.==.%%K. set RZ9=#
if .%RZ9%.==.. goto HELP
:0J
md5sum -b nuL | find "d41d8cd98f00b204e9800998ecf8427e *nuL" > NUL
if errorlevel 1 goto HELP
nset /? | find "NSET 2.1 (c) 1997 Horst Schaeffer - see DOC file" > NUL
if errorlevel 1 goto HELP
goto 0K
::
:MESSAGE
ctty con
echo  RFN.BAT -- Generate a random filename and SET the "RFN" environment variable.
echo             Type "RFN /?" for usage.
echo.
goto END
::
:HELP
ctty con
echo  RFN.BAT -- Generate a random filename and SET the "RFN" environment variable.
echo  *******                                          
echo                                                    Examples: RFN 8.2 d
echo  Usage: RFN [n[.x]] [[d]/[f/i]] [t/w] [e]                    RFN 2 i T E
echo             1 2 3 4         
echo.
echo     n - Number of characters in RFN (root); must be (1-8)  (required)
echo    .x - (1-3) character eXtension; may be trimmed if [i] is used (optional)
echo     d - Demo: Just ECHO the RFN to screen (don't SET "RFN" EV)  (optional)
echo     f - Full: Always generates [n[.x]] characters  (optional)
echo     i - Incremental: Generates [n[.x]] chars (if necessary)  (optional)
echo     t - Temp: RFN can exist in TEMP directory (requires [f/i])  (optional)
echo     w - Work: RFN can exist in WORK directory (requires [f/i])  (optional)
echo     e - Echo: Just ECHO the RFN to screen (don't SET "RFN" EV)  (optional)
echo     / - Choose one or the other, not both
echo.
echo     Note: Parameter 4 requires a Parameter 3, Param3 requires a Param2,...
echo.
echo  Requirements: MD5SUM.EXE / NSET.COM (v2.1)
echo.
goto 0S
::
:0K
for %%L in (RZ6 RZ5 RZ2 RZ1) do set %%L=
for %%M in (8 8.3 8.2 8.1) do if .%1.==.%%M. set RZ6=########
for %%N in (7 7.3 7.2 7.1) do if .%1.==.%%N. set RZ6=#######
for %%O in (6 6.3 6.2 6.1) do if .%1.==.%%O. set RZ6=######
for %%P in (5 5.3 5.2 5.1) do if .%1.==.%%P. set RZ6=#####
for %%Q in (4 4.3 4.2 4.1) do if .%1.==.%%Q. set RZ6=####
for %%R in (3 3.3 3.2 3.1) do if .%1.==.%%R. set RZ6=###
for %%S in (2 2.3 2.2 2.1) do if .%1.==.%%S. set RZ6=##
for %%T in (1 1.3 1.2 1.1) do if .%1.==.%%T. set RZ6=#
echo ,%1, | find ".3," > NUL
if not errorlevel 1 set RZ5=###
echo ,%1, | find ".2," > NUL
if not errorlevel 1 set RZ5=##
echo ,%1, | find ".1," > NUL
if not errorlevel 1 set RZ5=#
echo.|time|md5sum|nset /P01,32 /L1 RZ4=$0
goto 0M
:0L
echo %RZ4%%RZ3%|nset /P02,32 /L1 RZ4=$0
:0M
echo %RZ4%|nset /P01,02 /L1 RZ3=$0
goto 0N%RZ3%
:0Nff
:0Ncd
:0N9b
:0N69
:0N37
:0N05
set RZ2=%RZ2%Z
goto 0O
:0Nfe
:0Ncc
:0N9a
:0N68
:0N36
set RZ2=%RZ2%#
goto 0O
:0Nfd
:0Ncb
:0N99
:0N67
:0N35
set RZ2=%RZ2%Q
goto 0O
:0Nfc
:0Nca
:0N98
:0N66
:0N34
set RZ2=%RZ2%0
goto 0O
:0Nfb
:0Nc9
:0N97
:0N65
:0N33
set RZ2=%RZ2%V
goto 0O
:0Nfa
:0Nc8
:0N96
:0N64
:0N32
set RZ2=%RZ2%@
goto 0O
:0Nf9
:0Nc7
:0N95
:0N63
:0N31
set RZ2=%RZ2%X
goto 0O
:0Nf8
:0Nc6
:0N94
:0N62
:0N30
set RZ2=%RZ2%8
goto 0O
:0Nf7
:0Nc5
:0N93
:0N61
:0N2f
set RZ2=%RZ2%P
goto 0O
:0Nf6
:0Nc4
:0N92
:0N60
:0N2e
:0N04
set RZ2=%RZ2%&
goto 0O
:0Nf5
:0Nc3
:0N91
:0N5f
:0N2d
set RZ2=%RZ2%Y
goto 0O
:0Nf4
:0Nc2
:0N90
:0N5e
:0N2c
set RZ2=%RZ2%^
goto 0O
:0Nf3
:0Nc1
:0N8f
:0N5d
:0N2b
set RZ2=%RZ2%J
goto 0O
:0Nf2
:0Nc0
:0N8e
:0N5c
:0N2a
set RZ2=%RZ2%}
goto 0O
:0Nf1
:0Nbf
:0N8d
:0N5b
:0N29
set RZ2=%RZ2%B
goto 0O
:0Nf0
:0Nbe
:0N8c
:0N5a
:0N28
set RZ2=%RZ2%4
goto 0O
:0Nef
:0Nbd
:0N8b
:0N59
:0N27
set RZ2=%RZ2%W
goto 0O
:0Nee
:0Nbc
:0N8a
:0N58
:0N26
:0N03
set RZ2=%RZ2%$
goto 0O
:0Ned
:0Nbb
:0N89
:0N57
:0N25
set RZ2=%RZ2%F
goto 0O
:0Nec
:0Nba
:0N88
:0N56
:0N24
set RZ2=%RZ2%7
goto 0O
:0Neb
:0Nb9
:0N87
:0N55
:0N23
set RZ2=%RZ2%K
goto 0O
:0Nea
:0Nb8
:0N86
:0N54
:0N22
set RZ2=%RZ2%(
goto 0O
:0Ne9
:0Nb7
:0N85
:0N53
:0N21
set RZ2=%RZ2%D
goto 0O
:0Ne8
:0Nb6
:0N84
:0N52
:0N20
set RZ2=%RZ2%5
goto 0O
:0Ne7
:0Nb5
:0N83
:0N51
:0N1f
set RZ2=%RZ2%T
goto 0O
:0Ne6
:0Nb4
:0N82
:0N50
:0N1e
:0N02
set RZ2=%RZ2%C
goto 0O
:0Ne5
:0Nb3
:0N81
:0N4f
:0N1d
set RZ2=%RZ2%!
goto 0O
:0Ne4
:0Nb2
:0N80
:0N4e
:0N1c
set RZ2=%RZ2%G
goto 0O
:0Ne3
:0Nb1
:0N7f
:0N4d
:0N1b
set RZ2=%RZ2%3
goto 0O
:0Ne2
:0Nb0
:0N7e
:0N4c
:0N1a
set RZ2=%RZ2%R
goto 0O
:0Ne1
:0Naf
:0N7d
:0N4b
:0N19
set RZ2=%RZ2%{
goto 0O
:0Ne0
:0Nae
:0N7c
:0N4a
:0N18
set RZ2=%RZ2%H
goto 0O
:0Ndf
:0Nad
:0N7b
:0N49
:0N17
set RZ2=%RZ2%9
goto 0O
:0Nde
:0Nac
:0N7a
:0N48
:0N16
set RZ2=%RZ2%M
goto 0O
:0Ndd
:0Nab
:0N79
:0N47
:0N15
:0N01
set RZ2=%RZ2%_
goto 0O
:0Ndc
:0Naa
:0N78
:0N46
:0N14
set RZ2=%RZ2%S
goto 0O
:0Ndb
:0Na9
:0N77
:0N45
:0N13
set RZ2=%RZ2%6
goto 0O
:0Nda
:0Na8
:0N76
:0N44
:0N12
set RZ2=%RZ2%N
goto 0O
:0Nd9
:0Na7
:0N75
:0N43
:0N11
set RZ2=%RZ2%)
goto 0O
:0Nd8
:0Na6
:0N74
:0N42
:0N10
set RZ2=%RZ2%L
goto 0O
:0Nd7
:0Na5
:0N73
:0N41
:0N0f
set RZ2=%RZ2%'
goto 0O
:0Nd6
:0Na4
:0N72
:0N40
:0N0e
set RZ2=%RZ2%U
goto 0O
:0Nd5
:0Na3
:0N71
:0N3f
:0N0d
:0N00
set RZ2=%RZ2%~
goto 0O
:0Nd4
:0Na2
:0N70
:0N3e
:0N0c
set RZ2=%RZ2%O
goto 0O
:0Nd3
:0Na1
:0N6f
:0N3d
:0N0b
set RZ2=%RZ2%2
goto 0O
:0Nd2
:0Na0
:0N6e
:0N3c
:0N0a
set RZ2=%RZ2%I
goto 0O
:0Nd1
:0N9f
:0N6d
:0N3b
:0N09
set RZ2=%RZ2%-
goto 0O
:0Nd0
:0N9e
:0N6c
:0N3a
:0N08
set RZ2=%RZ2%E
goto 0O
:0Ncf
:0N9d
:0N6b
:0N39
:0N07
set RZ2=%RZ2%1
goto 0O
:0Nce
:0N9c
:0N6a
:0N38
:0N06
set RZ2=%RZ2%A
:0O
set RZ1=%RZ1%#
set RZ0=
if .%RZ8%.==.i. for %%U in (%RZ7%\%RZ2% %RZ7%\%RZ2%\nul) do if exist %%U set RZ0=#
if .%RZ8%.==.i. if not .%RZ0%.==.#. goto 0Q
if .%RZ1%.==.%RZ6%%RZ5%. goto 0P
if .%RZ1%.==.%RZ6%. if not .%RZ5%.==.. set RZ2=%RZ2%.
goto 0L
:0P
if .%RZ7%.==.. goto 0Q
set RZ0=
for %%V in (%RZ7%\%RZ2% %RZ7%\%RZ2%\nul) do if exist %%V set RZ0=#
if not .%RZ0%.==.#. goto 0Q
goto 0K
:0Q
ctty con
if .%RZ9%.==.#. goto 0R
set RFN=%RZ2%
goto 0S
:0R
echo %RZ2%
echo.
:0S
for %%W in (RZ9 RZ8 RZ7 RZ6 RZ5 RZ4 RZ3 RZ2 RZ1 RZ0) do set %%W=
:END